
/******************************************************************************
* MODULE     : modular_fft.hpp
* DESCRIPTION: Cutting integers into pieces for FFT-multiplication
* COPYRIGHT  : (C) 2008  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_MODULAR_FFT_HPP
#define __MMX_MODULAR_FFT_HPP
#include <numerix/complex_double.hpp>
#include <numerix/integer.hpp>
#include <algebramix/vector_unroll.hpp>
#include <algebramix/vector_simd.hpp>
namespace mmx {

void mpz_fft_encode (double* dest, const mpz_t& src, nat n, unsigned long cap);
  // break up an integer into n pieces of cap bits
void mpz_fft_decode (mpz_t& dest, const double* src, nat n, unsigned long cap);
  // reconstruct integer from pieces of cap bits
vector<double> fft_encode (const integer& i, const int& n, const int& cap);
  // high level interface for mpz_fft_encode
integer fft_decode (const vector<double>& v, const int& cap);
  // high level interface for mpz_fft_edecode

}
#endif // __MMX_MODULAR_FFT_HPP
