
/******************************************************************************
* MODULE     : cpp_syntax.hpp
* DESCRIPTION: C++ pretty printer
* COPYRIGHT  : (C) 2000  Joris van der Hoeven, 2007  Gregoire Lecerf
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __CPP_SYNTAX_HPP
#define __CPP_SYNTAX_HPP
#include <basix/string.hpp>

//! \file

namespace mmx {

extern generic CPP_ACCESS;
extern generic CPP_ALIAS;
extern generic CPP_AND;
extern generic CPP_APPLY;
extern generic CPP_ARROW;
extern generic CPP_ASSIGN;
extern generic CPP_BEGIN;
extern generic CPP_BITWISE_AND;
extern generic CPP_BITWISE_OR;
extern generic CPP_BITWISE_XOR;
extern generic CPP_BOOL;
extern generic CPP_BRACKETS;
extern generic CPP_BREAK;
extern generic CPP_CAST;
extern generic CPP_CATCH;
extern generic CPP_CLASS;
extern generic CPP_COMPLEMENT;
extern generic CPP_CONST;
extern generic CPP_CONSTRUCT;
extern generic CPP_CONSTRUCTOR;
extern generic CPP_CONTINUE;
extern generic CPP_DELETE;
extern generic CPP_DESTRUCTOR;
extern generic CPP_DIV;
extern generic CPP_DO;
extern generic CPP_DOT;
extern generic CPP_ELSE;
extern generic CPP_EQUAL;
extern generic CPP_EXIT;
extern generic CPP_EXTERN;
extern generic CPP_FOR;
extern generic CPP_GTR;
extern generic CPP_GTREQ;
extern generic CPP_GTRGTR;
extern generic CPP_IF;
extern generic CPP_INHERIT;
extern generic CPP_INITIALIZE;
extern generic CPP_INLINE;
extern generic CPP_INT;
extern generic CPP_LESS;
extern generic CPP_LESSEQ;
extern generic CPP_LESSLESS;
extern generic CPP_MINUS;
extern generic CPP_MINUS_ASSIGN;
extern generic CPP_MOD;
extern generic CPP_MOD_ASSIGN;
extern generic CPP_NAMESPACE;
extern generic CPP_NEW;
extern generic CPP_NOT;
extern generic CPP_OR;
extern generic CPP_OSTREAM;
extern generic CPP_OVER;
extern generic CPP_OVER_ASSIGN;
extern generic CPP_PLUS;
extern generic CPP_PLUS_ASSIGN;
extern generic CPP_POINTER;
extern generic CPP_POSTDEC;
extern generic CPP_POSTINC;
extern generic CPP_PREDEC;
extern generic CPP_PREINC;
extern generic CPP_PUBLIC;
extern generic CPP_RETURN;
extern generic CPP_SCOPE;
extern generic CPP_SPECIALIZE;
extern generic CPP_STATIC;
extern generic CPP_STRING;
extern generic CPP_STRUCT;
extern generic CPP_SWITCH;
extern generic CPP_TEMPLATE;
extern generic CPP_TIMES;
extern generic CPP_TIMES_ASSIGN;
extern generic CPP_THROW;
extern generic CPP_TRY;
extern generic CPP_TYPE;
extern generic CPP_TYPEDEF;
extern generic CPP_UNALIAS;
extern generic CPP_UNEQUAL;
extern generic CPP_UNFUNCTION;
extern generic CPP_UNPOINTER;
extern generic CPP_USING;
extern generic CPP_VERBATIM;
extern generic CPP_VIRTUAL;
extern generic CPP_VOID;
extern generic CPP_WHILE;
extern generic CPP_XOR;

string as_cpp (const generic& g);
string flatten_as_cpp (const generic& g);
void cpp_print (ostream& out, const generic& g);

} // namespace mmx
#endif // __CPP_SYNTAX_HPP
