
/******************************************************************************
* MODULE     : identifiers.hpp
* DESCRIPTION: Global definitions for common function names
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX__IDENTIFIERS_HPP__
#define __MMX__IDENTIFIERS_HPP__

//! \file

namespace mmx {
class string;
class generic;

extern generic GEN_ASSUME;
extern generic GEN_BEGIN;
extern generic GEN_BREAK;
extern generic GEN_CASE;
extern generic GEN_CATCH;
extern generic GEN_CATEGORY;
extern generic GEN_CLASS;
extern generic GEN_CONSTANT;
extern generic GEN_CONSTRUCTOR;
extern generic GEN_CONTINUE;
extern generic GEN_DESTRUCTOR;
extern generic GEN_ELSE;
extern generic GEN_ERROR;
extern generic GEN_EXISTS;
extern generic GEN_EXPORT;
extern generic GEN_EXTERN;
extern generic GEN_FOR;
extern generic GEN_FORALL;
extern generic GEN_FOREIGN;
extern generic GEN_GENERATE;
extern generic GEN_IF;
extern generic GEN_IMPORT;
extern generic GEN_IN;
extern generic GEN_INFIX;
extern generic GEN_INTERN;
extern generic GEN_KEYWORD;
extern generic GEN_LAMBDA;
extern generic GEN_LOOP;
extern generic GEN_METHOD;
extern generic GEN_MODULE;
extern generic GEN_MUTABLE;
extern generic GEN_OPERATOR;
extern generic GEN_POSTFIX;
extern generic GEN_PRIVATE;
extern generic GEN_PUBLIC;
extern generic GEN_PREFIX;
extern generic GEN_RAISE;
extern generic GEN_RETURN;
extern generic GEN_STEP;
extern generic GEN_THIS;
extern generic GEN_TRY;
extern generic GEN_UNTIL;
extern generic GEN_WHILE;
extern generic GEN_YIELD;

extern generic GEN_DEFINE;
extern generic GEN_ASSIGN;
extern generic GEN_PLUS_ASSIGN;
extern generic GEN_MINUS_ASSIGN;
extern generic GEN_TIMES_ASSIGN;
extern generic GEN_OVER_ASSIGN;
extern generic GEN_DEFINE_MACRO;
extern generic GEN_ASSIGN_MACRO;
extern generic GEN_LESSLESS;
extern generic GEN_GTRGTR;
extern generic GEN_IMPLIES;
extern generic GEN_EQUIV;
extern generic GEN_OR;
extern generic GEN_SEQOR;
extern generic GEN_XOR;
extern generic GEN_AND;
extern generic GEN_SEQAND;
extern generic GEN_EQUAL;
extern generic GEN_UNEQUAL;
extern generic GEN_LESS;
extern generic GEN_LESSEQ;
extern generic GEN_GTR;
extern generic GEN_GTREQ;
extern generic GEN_HAS;
extern generic GEN_TYPE;
extern generic GEN_TRANSTYPE;
extern generic GEN_CONVERTS;
extern generic GEN_INTO;
extern generic GEN_MAPSTO;
extern generic GEN_RANGE;
extern generic GEN_SCOPE;
extern generic GEN_TO;
extern generic GEN_DOWNTO;
extern generic GEN_PLUS;
extern generic GEN_TIMES;
extern generic GEN_OVER;
extern generic GEN_DIV;
extern generic GEN_MOD;
extern generic GEN_COMPOSE;
extern generic GEN_APPEND;
extern generic GEN_SIZE;
extern generic GEN_NOT;
extern generic GEN_MINUS;
extern generic GEN_POWER;
extern generic GEN_FILL;
extern generic GEN_EXPLODE;
extern generic GEN_FACTORIAL;
extern generic GEN_PRIME;
extern generic GEN_BACKPRIME;
extern generic GEN_STAR;
extern generic GEN_HAT;
extern generic GEN_TILDA;
extern generic GEN_DOT;
extern generic GEN_APPLY;
extern generic GEN_ACCESS;
extern generic GEN_TUPLE;
extern generic GEN_SQTUPLE;
extern generic GEN_ROW;
extern generic GEN_COMMA;
extern generic GEN_SEMICOLON;
extern generic GEN_WHERE;
extern generic GEN_VWHERE;
extern generic GEN_BACKQUOTE;
extern generic GEN_QUOTE;

extern generic GEN_CATALAN;
extern generic GEN_D;
extern generic GEN_DELTA;
extern generic GEN_E;
extern generic GEN_EULER;
extern generic GEN_FALSE;
extern generic GEN_FUZZ;
extern generic GEN_I;
extern generic GEN_INFINITY;
extern generic GEN_NAN;
extern generic GEN_NIL;
extern generic GEN_PARTIAL;
extern generic GEN_PI;
extern generic GEN_TRUE;

extern generic GEN_HARD_EQ;
extern generic GEN_HARD_NEQ;
extern generic GEN_EQ;
extern generic GEN_NEQ;
extern generic GEN_FLATTEN;
extern generic GEN_DUPLICATE;
extern generic GEN_FAST;
extern generic GEN_SLOW;
extern generic GEN_MUL_ADD;
extern generic GEN_MUL_SUB;
extern generic GEN_SQUARE;
extern generic GEN_GRAEFFE;
extern generic GEN_NUMERATOR;
extern generic GEN_DENOMINATOR;
extern generic GEN_GCD;
extern generic GEN_LCM;
extern generic GEN_XGCD;
extern generic GEN_SQRT;
extern generic GEN_EXP;
extern generic GEN_LOG;
extern generic GEN_COS;
extern generic GEN_SIN;
extern generic GEN_TAN;
extern generic GEN_ARCCOS;
extern generic GEN_ARCSIN;
extern generic GEN_ARCTAN;
extern generic GEN_CH;
extern generic GEN_SH;
extern generic GEN_TH;
extern generic GEN_ARGCH;
extern generic GEN_ARGSH;
extern generic GEN_ARGTH;
extern generic GEN_GAMMA;
extern generic GEN_ZETA;
extern generic GEN_ERF;
extern generic GEN_MIN;
extern generic GEN_MAX;
extern generic GEN_INF;
extern generic GEN_SUP;
extern generic GEN_ABS;
extern generic GEN_SIGN;
extern generic GEN_ARG;
extern generic GEN_RE;
extern generic GEN_IM;
extern generic GEN_CONJ;
extern generic GEN_BALL;
extern generic GEN_CENTER;
extern generic GEN_RADIUS;
extern generic GEN_SHARPEN;
extern generic GEN_CACHED_DERIVE;
extern generic GEN_DERIVE;
extern generic GEN_DERIVATIVE;
extern generic GEN_GRAD;
extern generic GEN_XDERIVE;
extern generic GEN_INTEGRATE;
extern generic GEN_REVERSE;
extern generic GEN_SUBSTITUTE;
extern generic GEN_SOLVE;

extern generic GEN_ALIAS_TYPE;
extern generic GEN_BOOLEAN_TYPE;
extern generic GEN_COMPOUND_TYPE;
extern generic GEN_CROSS_TYPE;
extern generic GEN_DOUBLE_TYPE;
extern generic GEN_FLOATING_TYPE;
extern generic GEN_FUNCTION_TYPE;
extern generic GEN_GENERATOR_TYPE;
extern generic GEN_GENERIC_TYPE;
extern generic GEN_GENERIC_ALIAS_TYPE;
extern generic GEN_INT_TYPE;
extern generic GEN_INTEGER_TYPE;
extern generic GEN_LITERAL_TYPE;
extern generic GEN_MACRO_TYPE;
extern generic GEN_RATIONAL_TYPE;
extern generic GEN_SINGLE_TYPE;
extern generic GEN_SYMBOL_TYPE;
extern generic GEN_THIS_TYPE;
extern generic GEN_TUPLE_TYPE;
extern generic GEN_TYPE_TYPE;
extern generic GEN_UNKNOWN_TYPE;
extern generic GEN_VOID_TYPE;

extern generic GEN_ALIAS;
extern generic GEN_ALL_TYPES;
extern generic GEN_CACHE_CONVERTER;
extern generic GEN_CACHE_CONVERTERS;
extern generic GEN_CACHE_PENALTY;
extern generic GEN_CLASS_NAME;
extern generic GEN_CLASS_MODE;
extern generic GEN_CLASS_ENCAPSULATION;
extern generic GEN_CLASS_ACCESS;
extern generic GEN_CLASS_FIELDS;
extern generic GEN_CLASS_EXPORT;
extern generic GEN_CLOSURE;
extern generic GEN_CONVERT;
extern generic GEN_CONVERTER;
extern generic GEN_CONVERTERS;
extern generic GEN_DOWNGRADE;
extern generic GEN_EMPTY;
extern generic GEN_EQUALIZE_GROUPED;
extern generic GEN_EXPECTED;
extern generic GEN_GLOBAL;
extern generic GEN_IDENTITY;
extern generic GEN_LIST;
extern generic GEN_LOCAL;
extern generic GEN_MACRO;
extern generic GEN_NEW;
extern generic GEN_PENALTY;
extern generic GEN_REWRITE;
extern generic GEN_SPECIALIZE_ALIAS;
extern generic GEN_SPECIALIZE;
extern generic GEN_TRANSITIVE;
extern generic GEN_TYPE_NAME;
extern generic GEN_TYPE_ID;
extern generic GEN_UNALIAS;
extern generic GEN_UPGRADE;
extern generic GEN_VIA_TUPLE;
extern generic GEN_EXCEPTION;
extern generic GEN_BACKTRACE;

} // namespace mmx
#endif // __MMX__IDENTIFIERS_HPP__
