
/******************************************************************************
* MODULE     : lisp_syntax.hpp
* DESCRIPTION: Parsing and printing expressions in lisp form
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SYNTAX_HPP
#define __SYNTAX_HPP
#include <basix/string.hpp>
#include <basix/syntactic.hpp>

//! \file

namespace mmx {

void lisp_print (ostream& out, const generic& g);
generic from_lisp (const string& s);

template<typename C> inline ostream&
print_lisp (ostream& out, const C& x) {
  lisp_print (out, flatten (x));
  return out;
}

} // namespace mmx
#endif // __SYNTAX_HPP
