
/******************************************************************************
* MODULE     : math_syntax.hpp
* DESCRIPTION: Mathematics printing for TeXmacs
* COPYRIGHT  : (C) 2007  Gregoire Lecerf
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MATH_SYNTAX_HPP
#define __MATH_SYNTAX_HPP
#include <basix/syntactic.hpp>

//! \file

namespace mmx {

/******************************************************************************
* Math output
******************************************************************************/

void math_print (ostream& out, const generic& g);

string as_texmacs_scheme (const generic& g);

template<typename C> inline ostream&
print_math (ostream& out, const C& x) {
  out << as_texmacs_scheme (as_generic (flatten (x)));
  return out;
  //math_print (out, as_generic (flatten (x)));
  //return out;
}

} // namespace mmx
#endif // __MATH_SYNTAX_HPP
