
/******************************************************************************
* MODULE     : parse_tools.hpp
* DESCRIPTION: Tools for parsing
* COPYRIGHT  : (C) 2007  Gregoire Lecerf
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __PARSE_TOOLS_HPP
#define __PARSE_TOOLS_HPP
#include <basix/source_track.hpp>
#include <basix/table.hpp>
#include <basix/compound.hpp>

//! \file

namespace mmx {

struct parse_instance {
MMX_ALLOCATORS
  // internal data for the parser
  string        lex_file_name; // name of the stream
                               // "" is reserved for stdin
  nat           lex_input_number; // number of the input in interactive mode
  
  char*         lex_string; // part of the stream to be parsed and
			    // starting at the above specified offset

  nat           lex_length; // length of lex_string

  nat           lex_start; // source_positions in lex_string used in the lexer
  nat           lex_start_line;
  nat           lex_start_begin_line;
  
  nat           lex_prev; 
  nat           lex_prev_line; 
  nat           lex_prev_begin_line; 

  nat           lex_pos; // current source_position in lex_string in the lexer
  nat           lex_line;
  nat           lex_begin_line;

  generic       result; // output of the parser

  list<generic> errors; // list of syntax error and warning

  parse_instance (const string& f, nat i, const string& s);
  // Setup with lex_file_name f, lex_string s and lex_input_number i
};

} // namespace mmx
#endif // __PARSE_TOOLS_HPP
