
/******************************************************************************
* MODULE     : program.hpp
* DESCRIPTION: Program as a wrapper class above dag
* COPYRIGHT  : (C) 2008  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX__PROGRAM__HPP
#define __MMX__PROGRAM__HPP
#include <basix/program_data.hpp>
#include <basix/program_control.hpp>

namespace mmx {
#define TMPL_DEF template<typename C, typename V= standard_program>
#define TMPL template<typename C, typename V>
#define Program program<C,V>

struct standard_program:
  public program_control<
         program_data<
         program_basic<basic_dag,program_dag<standard_program> > > > {};

TMPL_DEF
class program: public dag<C,program_dag<V> > {
public:
  inline program ():
    dag<C,program_dag<V> > () {}
  inline program (const dag<C,program_dag<V> >& d):
    dag<C,program_dag<V> > (d) {}
};

#undef TMPL_DEF
#undef TMPL
#undef Program
} // namespace mmx
#endif // __MMX__PROGRAM__HPP
