
/******************************************************************************
* MODULE     : threads.hpp
* DESCRIPTION: Multi-threading
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_THREADS_HPP
#define __MMX_THREADS_HPP
#include <basix/exception.hpp>

#ifdef BASIX_ENABLE_THREADS
#include <pthread.h>
#endif

//! \file

namespace mmx {

/******************************************************************************
* Parallel execution of tasks
******************************************************************************/

class task_rep REP_STRUCT {
public:
  inline task_rep () {}
  virtual ~task_rep () {}
  virtual void execute () = 0;
};

class task {
INDIRECT_PROTO (task, task_rep)
public:
  inline task (): rep (NULL) {}
};
INDIRECT_NULL_IMPL (task, task_rep)

extern nat  threads_number;
void threads_initialize (nat n);
void threads_terminate ();
void threads_execute (task* ts, nat n);
void threads_simple_loop (nat nr_instances, nat nr_iterations);
int  threads_get_number ();
void threads_set_number (const int& n);

} // namespace mmx

#endif // __MMX_THREADS_HPP
