
/******************************************************************************
* MODULE     : mmxlight_glue.hpp
* DESCRIPTION: Prototypes for some of the functions exported by the glue
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_MMXLIGHT_GLUE_HPP
#define __MMX_MMXLIGHT_GLUE_HPP
#include <basix/glue.hpp>
#include <basix/literal.hpp>
#include <basix/compound.hpp>
namespace mmx {

generic convert_to (const generic& r, nat t_id, const generic& where);
generic mmx_define (const generic& x);
void    mmx_set (const generic& var, const generic& val);
void    mmx_overload (const generic& var, const generic& val);

template<typename C> generic
eval_as (const generic& g) {
  generic r= eval (g);
  if (is<C> (r) || is<exception> (r)) return r;
  nat t_id= type_id<C> ();
  return convert_to (r, t_id, g);
}

} // namespace mmx
#endif // __MMX_MMXLIGHT_GLUE_HPP
