
/******************************************************************************
* MODULE     : block_polynomial_rational.hpp
* DESCRIPTION: Kronecker multiplication of multivariate rational polynomials
* COPYRIGHT  : (C) 2007  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_BLOCK_POLYNOMIAL_RATIONAL_HPP
#define __MMX_BLOCK_POLYNOMIAL_RATIONAL_HPP
#include <algebramix/polynomial_quotient.hpp>
#include <multimix/block_polynomial_integer.hpp>
namespace mmx {

void kronecker_mul (rational* dest,
		    const rational* src1, const vector<nat>& ords1,
		    const rational* src2, const vector<nat>& ords2);
void kronecker_square (rational* dest,
		       const rational* src1, const vector<nat>& ords1);

} // namespace mmx
#endif // __MMX_BLOCK_POLYNOMIAL_RATIONAL_HPP
