
/******************************************************************************
* MODULE     : complex_interval.hpp
* DESCRIPTION: Complexified intervals
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_COMPLEX_INTERVAL_HPP
#define __MMX_COMPLEX_INTERVAL_HPP
#include <numerix/interval.hpp>
#include <numerix/complex.hpp>
namespace mmx {
#define TMPL template<typename C>
#define Interval interval<C>
#define Complex complex<C>
#define Complex_interval complex<interval<C> >

TMPL
struct make_ball_helper<Complex_interval,Complex,C> {
  static inline Complex_interval val (const Complex& c, const C& r) {
    return Complex_interval (make_ball<Interval,C,C> (Re (c), r),
				make_ball<Interval,C,C> (Im (c), r)); }
};

TMPL inline C abs_down (const Complex_interval& z) {
  return lower (abs (z)); }
TMPL inline C abs_up (const Complex_interval& z) {
  return upper (abs (z)); }

#undef TMPL
#undef Interval
#undef Complex
#undef Complex_interval
} // namespace mmx
#endif // __MMX_COMPLEX_HPP
