
/******************************************************************************
* MODULE     : simd.hpp
* DESCRIPTION: General support for SIMD instructions
* COPYRIGHT  : (C) 2007  Joris van der Hoeven and Gregoire Lecerf
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_SIMD_HPP
#define __MMX_SIMD_HPP
#include <basix/fast_new.hpp>
#include <numerix/numerix-config.hpp>

#if ! (defined (NUMERIX_HAVE_STDINT_H) && defined (ENABLE_FAST_ALLOCATORS))
#undef NUMERIX_ENABLE_SIMD
#endif

/******************************************************************************
* Default simd helpers
******************************************************************************/

namespace mmx {

template<typename C> struct simd_helper {
  typedef C type;
  static const nat size = 1; };

template<typename C> struct simd_base_helper {
  typedef C type; };

#define Simd_type(C) simd_helper<C>::type
#define Simd_size(C) simd_helper<C>::size
#define Simd_base_type(C) simd_base_helper<C>::type

} // namespace mmx

#endif // __MMX_SIMD_HPP
