
/******************************************************************************
* MODULE     : string_scnot.hpp
* DESCRIPTION: Scientific notation for intervals
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __STRING_SCNOT_HPP
#define __STRING_SCNOT_HPP
#include <basix/string.hpp>
namespace mmx {

string make_range (const string& l, const string& r);
void decompose_range (const string& s, string& l, string& r);
string trunc_digits (const string& s, nat dd);
syntactic flatten_number (const string& s);

template<typename C> syntactic
flatten_range (const C& x, const C& y) {
  const string s= make_range (as_string (x), as_string (y));
  return flatten_number (s);
}

template<typename C> syntactic
flatten_range (const C& x, const C& y, nat dd) {
  const string s= trunc_digits (make_range (as_string (x), as_string (y)), dd);
  return flatten_number (s);
}

} // namespace mmx
#endif // __STRING_SCNOT_HPP
