/*********************************************************************
*    This file is part of the source code of SYNAPS library.         *
*    Author(s): B. Mourrain, GALAAD, INRIA                           *
**********************************************************************
History: $Id: xml.h,v 1.1 2005/07/11 09:32:55 mourrain Exp $
**********************************************************************/
#ifndef synaps_mpoldst_xml_hpp
#define synaps_mpoldst_xml_hpp
//--------------------------------------------------------------------
#include <subdivix/xml.hpp>
#include <subdivix/mpoldst.hpp>
//--------------------------------------------------------------------
namespace mmx {
//--------------------------------------------------------------------
namespace xml {

  /// Read a multivariate polynomial, enclosed in @polynomial@ tags.
  template<class ISTREAM, typename C, typename O, typename R>
  bool read(ISTREAM& is, mpoldst<C,O,R>& p)
  {
    return read_pol(is,p);
  }


  /// Read a multivariate polynomial, enclosed in @polynomial@ tags.
  template<class ISTREAM, typename C, typename O, typename R, typename VAR>
  bool read(ISTREAM& is, mpoldst<C,O,R>& p, const VAR& V)
  {
    return read_pol(is,p,V);
  }

  /// Print a multivariate polynomial, with its @polynomial@ tags.
  template<class OSTREAM, typename C,typename O,typename R>
  OSTREAM& print(OSTREAM& os, const mpoldst<C,O,R>& p)
  {
    xml::print(os,p,"polynomial");
    return os;
  }

}
//----------------------------------------------------------------------
} //namespace mmx
//----------------------------------------------------------------------
#endif //synaps_mpol_xml_hpp
