#ifndef SYNAPS_MPOLDSE_BERNSTEIN_H
#define SYNAPS_MPOLDSE_BERNSTEIN_H

#include "subdivix/multivariate_dense_monomial.hpp"

#define TMPL template<class C> 
#define Polynomial bernstein<C> 
namespace mmx {

namespace multivariate_dense
{
  template<class C>
  struct bernstein : monomial<C>
  {
    typedef monomial<C>   base_type;
    typedef typename base_type::value_type  value_type;
    typedef typename base_type::vector_type vector_type;
    typedef typename base_type::iterator    iterator;
    typedef typename base_type::const_iterator const_iterator;
    typedef typename base_type::size_type size_type;
    bernstein( const C& x = 0 );
    template<class X, class O, class R> 
    bernstein( const mpoldst<X,O,R>& mpol ):base_type(mpol) 
    {
      convertm2b(*this);
    };

    bernstein( const char* str ):base_type(mpoldst<C>(str)) 
    {
      convertm2b(*this);
    };
    template<class VECT> 
    bernstein( const char* str, const VECT& bx):base_type(mpoldst<C>(str)) 
    {
      convertm2b(*this, bx);
    };
    
    template<class X, class O, class R, class VECT> 
    bernstein( const mpoldst<X,O,R>& mpol, const VECT& bx ):base_type(mpol) 
    {
      convertm2b(*this, bx);
    }
    bernstein( const eenv & e);
    bernstein( const eenv& e, const C& c );
    bernstein( int nvr, const int * szs, const int * vrs = 0 );
    bernstein& operator=( const C& x );
    C& operator[]( int i ) { return this->data[i]; };
    const C& operator[]( int i ) const { return this->data[i]; };
    bool operator==( const C& c ) const { return base_type::esz() == 1 && base_type::data[0] == c; };
    bool operator==( const bernstein& mp ) const;
  };
  

  template<class C> inline
  unsigned size(const bernstein<C>& p) {return p.size();}

  TMPL Polynomial diff(const Polynomial& p, int v)
  {
    Polynomial dp(p);   diff(dp,p,v);   return dp;
  }

};

} //namespace mmx

#include "multivariate_dense_bernstein_c.hpp"

#undef TMPL
#undef Polynomial
#endif /* SYNAPS_MPOLDSE_BERNSTEIN_H */
