#ifndef subdivix_multivariate_dense_convert_hpp
#define subdivix_multivariate_dense_convert_hpp
namespace mmx {

  namespace multivariate_dense {
    //--------------------------------------------------------------------
    /** Convert a multivariate polynomial to univariate one, formally by substuting
	all the variables but the variable of index \c ind by 1.
    **/
    template<class UPOL,class MPOL>
    UPOL convert(const MPOL & p, unsigned v)
    {
      unsigned N = degree(p,v)+1;
      UPOL r(N, AsSize());
      for(unsigned i =0; i<N;i++) { slice(r[i].rep(),p.rep(),v,i); }
      return r;
    }
  }
}
#endif // SYNAPS_MPOL_MPOLDSE_CONVERT_H
