/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 ********************************************************************/
#ifndef mmx_basix_set_of_hpp
#define mmx_basix_set_of_hpp
//===================================================================
#include <basix/basix.hpp>
#include <basix/glue.hpp>
//#include <basix/category_glue.hpp>
//#include <basix/category_lift_glue.hpp>
//====================================================================
namespace mmx {
//===================================================================

  template<class X> struct set_of
  {
    typedef X T;
    set_of(){}
    set_of(const set_of<X>& t) {}
    set_of(const X& x) {}
  };
  
  template<class X> 
  bool operator== (const set_of<X>& r1, const set_of<X>& r2) { return true; }
  template<class X> 
  bool operator!= (const set_of<X>& r1, const set_of<X>& r2) { return !(r1==r2); }
  
  template<class C> inline set_of<C> make_set(const C& c) { return set_of<C>(); }
  template<class C> inline int hash(const set_of<C>& R){ return 1;}
  template<class C> inline int soft_hash(const set_of<C>& R){ return 1;}
  template<class C> inline bool eq(const set_of<C>& R1, const set_of<C>& R2) 
  {
    return R1==R2;
  }

  template<class X> inline syntactic flatten(const set_of<X>& s)
  {
    return syntactic("XXX");//type_name< X >());
  }

  template<typename U,typename T>
  struct as_helper<set_of<U>,set_of<T> >
  {
    static inline 
    set_of<U> cv (const set_of<T>& x) { return set_of<U>(); }
  };

#define DECLARE_SET(X,T)                                       \
template<> inline syntactic flatten(const set_of<T>& Z){return syntactic(X);}

#define DEFINE_SET(X,T)                                        \
  static set_of<T> T##_set= set_of<T>();                             \
  define_constant<always,set_of<T> > (X, T##_set);                \
  define<always> ("set_of", make_set<T>); 

//===================================================================
}
#endif //
