#ifndef SYNAPS_ARITHM_TRAITS_HASFUNCTION_H
#define SYNAPS_ARITHM_TRAITS_HASFUNCTION_H


namespace mmx {

#define simple_trait(name,default)\
template< typename X > struct name##_ { typedef default T; };\
template< typename X > struct name { typedef typename name##_< typename meta::ucstref<X>::T >::T T; };\

namespace meta {
  
  simple_trait(hasgcd,false_t);
  simple_trait(hassqrt,false_t);
  simple_trait(hasisqrt,false_t);

  template< typename X >
    struct hasfunction
    {
      typedef typename hasgcd  < typename meta::ucstref<X>::T >::T  gcd;
      typedef typename hassqrt < typename meta::ucstref<X>::T >::T  sqrt;
      typedef typename hasisqrt< typename meta::ucstref<X>::T >::T isqrt;
    }; 
}

}// end namespace mmx

#endif

