#ifndef SYNAPS_ARITHM_TRAITS_ISFIELD_H
#define SYNAPS_ARITHM_TRAITS_ISFIELD_H

#include <subdivix/texp_kernelof.hpp>

//======================================================================
namespace mmx {
//======================================================================

namespace meta {

  template<typename X>
  struct isfield_ { typedef false_t T; };
  
  template<> struct isfield_<float>       { typedef true_t T; };
  template<> struct isfield_<double>      { typedef true_t T; };
  template<> struct isfield_<long double> { typedef true_t T; };

  template<typename K, typename X>
  struct kernel_isfield { typedef true_t T; };
  template<typename K>
  struct kernel_isfield< K, typename K::integer > { typedef false_t T; };
  template<typename X>
  struct kernel_isfield<null_t,X> { typedef typename isfield_<X>::T T; };
  
  template<typename X>
  struct isfield
  {
    typedef  typename ucstref<X>::T   _X;
    typedef  typename kernel_isfield< typename kernelof<_X>::T, _X >::T T;
  };

};

//======================================================================
} //  namespace mmx 
//======================================================================

#endif
