#ifndef SYNAPS_ARITHM_TRAITS_KERNELOF_H
#define SYNAPS_ARITHM_TRAITS_KERNELOF_H
#include <subdivix/type.hpp>

namespace mmx {

template<class K> struct algebraic;

namespace meta {

  using namespace meta;

  template<class mplib, typename _ieee_ = double >
  struct kernel
    {
      typedef typename mplib::integer  integer;
      typedef typename mplib::rational rational;
      typedef typename mplib::floating floating;
      typedef _ieee_                   ieee;
    };
  
  /// return the arithmetic kernel from which the unqualified type X comes from.
  template<class X>
  struct kernelof_ { typedef null_t T; };
  template<class K>
  struct kernelof_< algebraic<K> > { typedef K T; };

  /// return the arithmetic kernel from which the type X comes from.
  template<class X>
  struct kernelof { typedef typename kernelof_< typename ucstref<X>::T >::T T; };
  /// return true_t if the number type X comes from a kernel.
  template<class X>
  struct haskernel { typedef typename tnot< typename equal< null_t, typename kernelof<X>::T >::T >::T T; };
  

};

}// end namespace mmx

#endif
