
/******************************************************************************
* MODULE     : symbolic_standard.hpp
* DESCRIPTION: Standard symbolic expressions
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SYMBOLIC_STANDARD__HPP
#define __SYMBOLIC_STANDARD__HPP
#include <symbolix/symbolic_internal.hpp>
#include <symbolix/symbolic_default.hpp>
#include <symbolix/symbolic_scalar.hpp>
#include <symbolix/symbolic_sum.hpp>
#include <symbolix/symbolic_product.hpp>
#include <symbolix/symbolic_elementary.hpp>
#include <symbolix/symbolic_apply.hpp>
#include <symbolix/symbolic_derive.hpp>
#include <symbolix/symbolic_substitute.hpp>
#include <symbolix/symbolic_solve.hpp>
#include <symbolix/simplify_regroup.hpp>
namespace mmx {

template<typename R>
struct std_symbolic:
  public simplify_regroup<
         symbolic_solve<
         symbolic_substitute<
         symbolic_derive<
         symbolic_apply<
         symbolic_elementary<
         symbolic_product<
         symbolic_sum<
         symbolic_scalar<
         symbolic_default<
	 symbolic_internal<R,std_symbolic<R> > > > > > > > > > > > {};

} // namespace mmx
#endif // __SYMBOLIC_STANDARD__HPP
